import{S as Kr,i as Yr,s as Jr,e as n,k as d,w as u,t as o,M as Xr,c as a,d as s,m as c,a as i,x as m,h as r,b as f,G as t,g as p,y as h,q as g,o as _,B as b,v as Qr,L as el}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as js}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as D}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as K}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as tl}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function sl(Ds){let w,Y,y,P,S;return P=new D({props:{code:`import requests
import torch

from diffusers import DDIMScheduler, StableDiffusionPix2PixZeroPipeline


def download(embedding_url, local_filepath):
    r = requests.get(embedding_url)
    with open(local_filepath, "wb") as f:
        f.write(r.content)


model_ckpt = "CompVis/stable-diffusion-v1-4"
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    model_ckpt, conditions_input_image=False, torch_dtype=torch.float16
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.to("cuda")

prompt = "a high resolution painting of a cat in the style of van gough"
source_emb_url = "https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/cat.pt"
target_emb_url = "https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/dog.pt"

for url in [source_emb_url, target_emb_url]:
    download(url, url.split("/")[-1])

src_embeds = torch.load(source_emb_url.split("/")[-1])
target_embeds = torch.load(target_emb_url.split("/")[-1])
images = pipeline(
    prompt,
    source_embeds=src_embeds,
    target_embeds=target_embeds,
    num_inference_steps=50,
    cross_attention_guidance_amount=0.15,
).images
images[0].save("edited_image_dog.png")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler, StableDiffusionPix2PixZeroPipeline


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">download</span>(<span class="hljs-params">embedding_url, local_filepath</span>):
<span class="hljs-meta">... </span>    r = requests.get(embedding_url)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">with</span> <span class="hljs-built_in">open</span>(local_filepath, <span class="hljs-string">&quot;wb&quot;</span>) <span class="hljs-keyword">as</span> f:
<span class="hljs-meta">... </span>        f.write(r.content)


<span class="hljs-meta">&gt;&gt;&gt; </span>model_ckpt = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
<span class="hljs-meta">... </span>    model_ckpt, conditions_input_image=<span class="hljs-literal">False</span>, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;a high resolution painting of a cat in the style of van gough&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>source_emb_url = <span class="hljs-string">&quot;https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/cat.pt&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_emb_url = <span class="hljs-string">&quot;https://hf.co/datasets/sayakpaul/sample-datasets/resolve/main/dog.pt&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> url <span class="hljs-keyword">in</span> [source_emb_url, target_emb_url]:
<span class="hljs-meta">... </span>    download(url, url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>src_embeds = torch.load(source_emb_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_embeds = torch.load(target_emb_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipeline(
<span class="hljs-meta">... </span>    prompt,
<span class="hljs-meta">... </span>    source_embeds=src_embeds,
<span class="hljs-meta">... </span>    target_embeds=target_embeds,
<span class="hljs-meta">... </span>    num_inference_steps=<span class="hljs-number">50</span>,
<span class="hljs-meta">... </span>    cross_attention_guidance_amount=<span class="hljs-number">0.15</span>,
<span class="hljs-meta">... </span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;edited_image_dog.png&quot;</span>)`}}),{c(){w=n("p"),Y=o("Examples:"),y=d(),u(P.$$.fragment)},l(v){w=a(v,"P",{});var q=i(w);Y=r(q,"Examples:"),q.forEach(s),y=c(v),m(P.$$.fragment,v)},m(v,q){p(v,w,q),t(w,Y),p(v,y,q),h(P,v,q),S=!0},p:el,i(v){S||(g(P.$$.fragment,v),S=!0)},o(v){_(P.$$.fragment,v),S=!1},d(v){v&&s(w),v&&s(y),b(P,v)}}}function nl(Ds){let w,Y,y,P,S,v,q,It,Mn,Es,A,J,Ct,ue,Gn,zt,On,Ss,me,he,Fn,Bn,qs,it,Un,Ts,ot,Zt,Hn,Is,rt,Rn,Cs,T,lt,ge,Wn,Vn,Kn,pt,_e,Yn,Jn,Xn,dt,be,Qn,ea,zs,L,X,At,ve,ta,Lt,sa,Zs,$,Nt,na,aa,j,ia,Mt,oa,ra,Gt,la,pa,Ot,da,ca,Ft,fa,ua,ma,N,ha,Bt,ga,_a,Ut,ba,va,xa,ct,wa,xe,M,Pa,Ht,ya,$a,Rt,ka,ja,Da,Wt,Ea,Sa,we,qa,Pe,Ta,Ia,As,G,Q,Vt,ye,Ca,Kt,za,Ls,ee,Yt,O,Jt,Za,Aa,Xt,La,Na,ft,Ma,Ga,Qt,F,es,$e,Oa,Fa,ts,ss,Ba,Ua,ut,Ha,Ns,B,te,ns,ke,Ra,as,Wa,Ms,U,se,is,je,Va,os,Ka,Gs,De,Os,H,ne,rs,Ee,Ya,ls,Ja,Fs,ae,Xa,ps,Qa,ei,Bs,mt,ti,Us,Se,Hs,ht,si,Rs,qe,Ws,gt,ni,Vs,Te,Ks,_t,ai,Ys,Ie,Js,R,ie,ds,Ce,ii,cs,oi,Xs,E,ri,ze,li,pi,Ze,di,ci,Ae,fi,ui,Qs,Le,fs,mi,hi,en,Ne,tn,Me,us,gi,_i,sn,Ge,nn,bt,bi,an,Oe,ms,vi,xi,on,vt,wi,rn,Fe,ln,xt,Pi,pn,Be,dn,I,yi,hs,$i,ki,Ue,ji,Di,cn,He,gs,Ei,Si,fn,wt,qi,un,Re,mn,We,_s,Ti,Ii,hn,Ve,gn,oe,Ci,Ke,zi,Zi,_n,Pt,Ai,bn,Ye,vn,W,re,bs,Je,Li,vs,Ni,xn,x,Xe,Mi,xs,Gi,Oi,Qe,Fi,yt,Bi,Ui,Hi,C,et,Ri,ws,Wi,Vi,le,Ki,pe,tt,Yi,Ps,Ji,Xi,de,st,Qi,V,eo,ys,to,so,$s,no,ao,io,ce,nt,oo,ks,ro,wn;return v=new K({}),ue=new K({}),ve=new K({}),ye=new K({}),ke=new K({}),je=new K({}),De=new D({props:{code:`import requests
import torch

from diffusers import DDIMScheduler, StableDiffusionPix2PixZeroPipeline


def download(embedding_url, local_filepath):
    r = requests.get(embedding_url)
    with open(local_filepath, "wb") as f:
        f.write(r.content)


model_ckpt = "CompVis/stable-diffusion-v1-4"
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    model_ckpt, conditions_input_image=False, torch_dtype=torch.float16
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.to("cuda")

prompt = "a high resolution painting of a cat in the style of van gough"
src_embs_url = "https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/cat.pt"
target_embs_url = "https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/dog.pt"

for url in [src_embs_url, target_embs_url]:
    download(url, url.split("/")[-1])

src_embeds = torch.load(src_embs_url.split("/")[-1])
target_embeds = torch.load(target_embs_url.split("/")[-1])

images = pipeline(
    prompt,
    source_embeds=src_embeds,
    target_embeds=target_embeds,
    num_inference_steps=50,
    cross_attention_guidance_amount=0.15,
).images
images[0].save("edited_image_dog.png")`,highlighted:`<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">import</span> torch

<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler, StableDiffusionPix2PixZeroPipeline


<span class="hljs-keyword">def</span> <span class="hljs-title function_">download</span>(<span class="hljs-params">embedding_url, local_filepath</span>):
    r = requests.get(embedding_url)
    <span class="hljs-keyword">with</span> <span class="hljs-built_in">open</span>(local_filepath, <span class="hljs-string">&quot;wb&quot;</span>) <span class="hljs-keyword">as</span> f:
        f.write(r.content)


model_ckpt = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    model_ckpt, conditions_input_image=<span class="hljs-literal">False</span>, torch_dtype=torch.float16
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a high resolution painting of a cat in the style of van gough&quot;</span>
src_embs_url = <span class="hljs-string">&quot;https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/cat.pt&quot;</span>
target_embs_url = <span class="hljs-string">&quot;https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/embeddings_sd_1.4/dog.pt&quot;</span>

<span class="hljs-keyword">for</span> url <span class="hljs-keyword">in</span> [src_embs_url, target_embs_url]:
    download(url, url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])

src_embeds = torch.load(src_embs_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])
target_embeds = torch.load(target_embs_url.split(<span class="hljs-string">&quot;/&quot;</span>)[-<span class="hljs-number">1</span>])

images = pipeline(
    prompt,
    source_embeds=src_embeds,
    target_embeds=target_embeds,
    num_inference_steps=<span class="hljs-number">50</span>,
    cross_attention_guidance_amount=<span class="hljs-number">0.15</span>,
).images
images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;edited_image_dog.png&quot;</span>)`}}),Ee=new K({}),Se=new D({props:{code:`import torch
from transformers import BlipForConditionalGeneration, BlipProcessor
from diffusers import DDIMScheduler, DDIMInverseScheduler, StableDiffusionPix2PixZeroPipeline

captioner_id = "Salesforce/blip-image-captioning-base"
processor = BlipProcessor.from_pretrained(captioner_id)
model = BlipForConditionalGeneration.from_pretrained(captioner_id, torch_dtype=torch.float16, low_cpu_mem_usage=True)

sd_model_ckpt = "CompVis/stable-diffusion-v1-4"
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    sd_model_ckpt,
    caption_generator=model,
    caption_processor=processor,
    torch_dtype=torch.float16,
    safety_checker=None,
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)
pipeline.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> BlipForConditionalGeneration, BlipProcessor
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler, DDIMInverseScheduler, StableDiffusionPix2PixZeroPipeline

captioner_id = <span class="hljs-string">&quot;Salesforce/blip-image-captioning-base&quot;</span>
processor = BlipProcessor.from_pretrained(captioner_id)
model = BlipForConditionalGeneration.from_pretrained(captioner_id, torch_dtype=torch.float16, low_cpu_mem_usage=<span class="hljs-literal">True</span>)

sd_model_ckpt = <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    sd_model_ckpt,
    caption_generator=model,
    caption_processor=processor,
    torch_dtype=torch.float16,
    safety_checker=<span class="hljs-literal">None</span>,
)
pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)
pipeline.inverse_scheduler = DDIMInverseScheduler.from_config(pipeline.scheduler.config)
pipeline.enable_model_cpu_offload()`}}),qe=new D({props:{code:`import requests
from PIL import Image

img_url = "https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/test_images/cats/cat_6.png"
raw_image = Image.open(requests.get(img_url, stream=True).raw).convert("RGB").resize((512, 512))
caption = pipeline.generate_caption(raw_image)`,highlighted:`<span class="hljs-keyword">import</span> requests
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

img_url = <span class="hljs-string">&quot;https://github.com/pix2pixzero/pix2pix-zero/raw/main/assets/test_images/cats/cat_6.png&quot;</span>
raw_image = Image.<span class="hljs-built_in">open</span>(requests.get(img_url, stream=<span class="hljs-literal">True</span>).raw).convert(<span class="hljs-string">&quot;RGB&quot;</span>).resize((<span class="hljs-number">512</span>, <span class="hljs-number">512</span>))
caption = pipeline.generate_caption(raw_image)`}}),Te=new D({props:{code:"inv_latents, inv_image = pipeline.invert(caption, image=raw_image)",highlighted:"inv_latents, inv_image = pipeline.invert(caption, image=raw_image)"}}),Ie=new D({props:{code:`# See the "Generating source and target embeddings" section below to
# automate the generation of these captions with a pre-trained model like Flan-T5.
source_prompts = ["a cat sitting on the street", "a cat playing in the field", "a face of a cat"]
target_prompts = ["a dog sitting on the street", "a dog playing in the field", "a face of a dog"]

source_embeds = pipeline.get_embeds(source_prompts, batch_size=2)
target_embeds = pipeline.get_embeds(target_prompts, batch_size=2)


image = pipeline(
    caption,
    source_embeds=source_embeds,
    target_embeds=target_embeds,
    num_inference_steps=50,
    cross_attention_guidance_amount=0.15,
    generator=generator,
    latents=inv_latents,
    negative_prompt=caption,
).images[0]
image.save("edited_image.png")`,highlighted:`<span class="hljs-comment"># See the &quot;Generating source and target embeddings&quot; section below to</span>
<span class="hljs-comment"># automate the generation of these captions with a pre-trained model like Flan-T5.</span>
source_prompts = [<span class="hljs-string">&quot;a cat sitting on the street&quot;</span>, <span class="hljs-string">&quot;a cat playing in the field&quot;</span>, <span class="hljs-string">&quot;a face of a cat&quot;</span>]
target_prompts = [<span class="hljs-string">&quot;a dog sitting on the street&quot;</span>, <span class="hljs-string">&quot;a dog playing in the field&quot;</span>, <span class="hljs-string">&quot;a face of a dog&quot;</span>]

source_embeds = pipeline.get_embeds(source_prompts, batch_size=<span class="hljs-number">2</span>)
target_embeds = pipeline.get_embeds(target_prompts, batch_size=<span class="hljs-number">2</span>)


image = pipeline(
    caption,
    source_embeds=source_embeds,
    target_embeds=target_embeds,
    num_inference_steps=<span class="hljs-number">50</span>,
    cross_attention_guidance_amount=<span class="hljs-number">0.15</span>,
    generator=generator,
    latents=inv_latents,
    negative_prompt=caption,
).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;edited_image.png&quot;</span>)`}}),Ce=new K({}),Ne=new D({props:{code:`import torch
from transformers import AutoTokenizer, T5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained("google/flan-t5-xl")
model = T5ForConditionalGeneration.from_pretrained("google/flan-t5-xl", device_map="auto", torch_dtype=torch.float16)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, T5ForConditionalGeneration

tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;google/flan-t5-xl&quot;</span>)
model = T5ForConditionalGeneration.from_pretrained(<span class="hljs-string">&quot;google/flan-t5-xl&quot;</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>, torch_dtype=torch.float16)`}}),Ge=new D({props:{code:`source_concept = "cat"
target_concept = "dog"

source_text = f"Provide a caption for images containing a {source_concept}. "
"The captions should be in English and should be no longer than 150 characters."

target_text = f"Provide a caption for images containing a {target_concept}. "
"The captions should be in English and should be no longer than 150 characters."`,highlighted:`source_concept = <span class="hljs-string">&quot;cat&quot;</span>
target_concept = <span class="hljs-string">&quot;dog&quot;</span>

source_text = <span class="hljs-string">f&quot;Provide a caption for images containing a <span class="hljs-subst">{source_concept}</span>. &quot;</span>
<span class="hljs-string">&quot;The captions should be in English and should be no longer than 150 characters.&quot;</span>

target_text = <span class="hljs-string">f&quot;Provide a caption for images containing a <span class="hljs-subst">{target_concept}</span>. &quot;</span>
<span class="hljs-string">&quot;The captions should be in English and should be no longer than 150 characters.&quot;</span>`}}),Fe=new D({props:{code:`def generate_captions(input_prompt):
    input_ids = tokenizer(input_prompt, return_tensors="pt").input_ids.to("cuda")

    outputs = model.generate(
        input_ids, temperature=0.8, num_return_sequences=16, do_sample=True, max_new_tokens=128, top_k=10
    )
    return tokenizer.batch_decode(outputs, skip_special_tokens=True)`,highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_captions</span>(<span class="hljs-params">input_prompt</span>):
    input_ids = tokenizer(input_prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids.to(<span class="hljs-string">&quot;cuda&quot;</span>)

    outputs = model.generate(
        input_ids, temperature=<span class="hljs-number">0.8</span>, num_return_sequences=<span class="hljs-number">16</span>, do_sample=<span class="hljs-literal">True</span>, max_new_tokens=<span class="hljs-number">128</span>, top_k=<span class="hljs-number">10</span>
    )
    <span class="hljs-keyword">return</span> tokenizer.batch_decode(outputs, skip_special_tokens=<span class="hljs-literal">True</span>)`}}),Be=new D({props:{code:`source_captions = generate_captions(source_text)
target_captions = generate_captions(target_concept)`,highlighted:`source_captions = generate_captions(source_text)
target_captions = generate_captions(target_concept)`}}),Re=new D({props:{code:`from diffusers import StableDiffusionPix2PixZeroPipeline 

pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    "CompVis/stable-diffusion-v1-4", torch_dtype=torch.float16
)
pipeline = pipeline.to("cuda")
tokenizer = pipeline.tokenizer
text_encoder = pipeline.text_encoder`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPix2PixZeroPipeline 

pipeline = StableDiffusionPix2PixZeroPipeline.from_pretrained(
    <span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>, torch_dtype=torch.float16
)
pipeline = pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)
tokenizer = pipeline.tokenizer
text_encoder = pipeline.text_encoder`}}),Ve=new D({props:{code:`import torch 

def embed_captions(sentences, tokenizer, text_encoder, device="cuda"):
    with torch.no_grad():
        embeddings = []
        for sent in sentences:
            text_inputs = tokenizer(
                sent,
                padding="max_length",
                max_length=tokenizer.model_max_length,
                truncation=True,
                return_tensors="pt",
            )
            text_input_ids = text_inputs.input_ids
            prompt_embeds = text_encoder(text_input_ids.to(device), attention_mask=None)[0]
            embeddings.append(prompt_embeds)
    return torch.concatenate(embeddings, dim=0).mean(dim=0).unsqueeze(0)

source_embeddings = embed_captions(source_captions, tokenizer, text_encoder)
target_embeddings = embed_captions(target_captions, tokenizer, text_encoder)`,highlighted:`<span class="hljs-keyword">import</span> torch 

<span class="hljs-keyword">def</span> <span class="hljs-title function_">embed_captions</span>(<span class="hljs-params">sentences, tokenizer, text_encoder, device=<span class="hljs-string">&quot;cuda&quot;</span></span>):
    <span class="hljs-keyword">with</span> torch.no_grad():
        embeddings = []
        <span class="hljs-keyword">for</span> sent <span class="hljs-keyword">in</span> sentences:
            text_inputs = tokenizer(
                sent,
                padding=<span class="hljs-string">&quot;max_length&quot;</span>,
                max_length=tokenizer.model_max_length,
                truncation=<span class="hljs-literal">True</span>,
                return_tensors=<span class="hljs-string">&quot;pt&quot;</span>,
            )
            text_input_ids = text_inputs.input_ids
            prompt_embeds = text_encoder(text_input_ids.to(device), attention_mask=<span class="hljs-literal">None</span>)[<span class="hljs-number">0</span>]
            embeddings.append(prompt_embeds)
    <span class="hljs-keyword">return</span> torch.concatenate(embeddings, dim=<span class="hljs-number">0</span>).mean(dim=<span class="hljs-number">0</span>).unsqueeze(<span class="hljs-number">0</span>)

source_embeddings = embed_captions(source_captions, tokenizer, text_encoder)
target_embeddings = embed_captions(target_captions, tokenizer, text_encoder)`}}),Ye=new D({props:{code:`from diffusers import DDIMScheduler

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)

images = pipeline(
    prompt,
    source_embeds=source_embeddings,
    target_embeds=target_embeddings,
    num_inference_steps=50,
    cross_attention_guidance_amount=0.15,
).images
images[0].save("edited_image_dog.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMScheduler

pipeline.scheduler = DDIMScheduler.from_config(pipeline.scheduler.config)

images = pipeline(
    prompt,
    source_embeds=source_embeddings,
    target_embeds=target_embeddings,
    num_inference_steps=<span class="hljs-number">50</span>,
    cross_attention_guidance_amount=<span class="hljs-number">0.15</span>,
).images
images[<span class="hljs-number">0</span>].save(<span class="hljs-string">&quot;edited_image_dog.png&quot;</span>)`}}),Je=new K({}),Xe=new js({props:{name:"class diffusers.StableDiffusionPix2PixZeroPipeline",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddpm.DDPMScheduler, diffusers.schedulers.scheduling_ddim.DDIMScheduler, diffusers.schedulers.scheduling_euler_ancestral_discrete.EulerAncestralDiscreteScheduler, diffusers.schedulers.scheduling_lms_discrete.LMSDiscreteScheduler]"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"conditions_input_image",val:": bool = False"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, <a href="/docs/diffusers/main/en/api/schedulers/euler_ancestral#diffusers.EulerAncestralDiscreteScheduler">EulerAncestralDiscreteScheduler</a>, or <a href="/docs/diffusers/main/en/api/schedulers/ddpm#diffusers.DDPMScheduler">DDPMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.conditions_input_image",description:`<strong>conditions_input_image</strong> (bool) &#x2014;
Whether to condition the pipeline with an input image to compute an inverted noise latent.`,name:"conditions_input_image"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.requires_safety_checker",description:`<strong>requires_safety_checker</strong> (bool) &#x2014;
Whether the pipeline requires a safety checker. We recommend setting it to True if you&#x2019;re using the
pipeline publicly.`,name:"requires_safety_checker"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L156"}}),et=new js({props:{name:"__call__",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, NoneType] = None"},{name:"source_embeds",val:": Tensor = None"},{name:"target_embeds",val:": Tensor = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"cross_attention_guidance_amount",val:": float = 0.1"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": typing.Optional[int] = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code>, <em>optional</em>) &#x2014;
<code>Image</code>, or tensor representing an image batch which will be used for conditioning.`,name:"image"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.source_embeds",description:`<strong>source_embeds</strong> (<code>torch.Tensor</code>) &#x2014;
Source concept embeddings. Generation of the embeddings as per the <a href="https://arxiv.org/abs/2302.03027" rel="nofollow">original
paper</a>. Used in discovering the edit direction.`,name:"source_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.target_embeds",description:`<strong>target_embeds</strong> (<code>torch.Tensor</code>) &#x2014;
Target concept embeddings. Generation of the embeddings as per the <a href="https://arxiv.org/abs/2302.03027" rel="nofollow">original
paper</a>. Used in discovering the edit direction.`,name:"target_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. If not defined, one has to pass <code>negative_prompt_embeds</code>. instead.
Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/main/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.cross_attention_guidance_amount",description:`<strong>cross_attention_guidance_amount</strong> (<code>float</code>, defaults to 0.1) &#x2014;
Amount of guidance needed from the reference cross-attention maps.`,name:"cross_attention_guidance_amount"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L565",returnDescription:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),le=new tl({props:{anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.__call__.example",$$slots:{default:[sl]},$$scope:{ctx:Ds}}}),tt=new js({props:{name:"construct_direction",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.construct_direction",parameters:[{name:"embs_source",val:": Tensor"},{name:"embs_target",val:": Tensor"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L541"}}),st=new js({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L250"}}),nt=new js({props:{name:"generate_caption",anchor:"diffusers.StableDiffusionPix2PixZeroPipeline.generate_caption",parameters:[{name:"image",val:""},{name:"return_image",val:" = True"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py#L531"}}),{c(){w=n("meta"),Y=d(),y=n("h1"),P=n("a"),S=n("span"),u(v.$$.fragment),q=d(),It=n("span"),Mn=o("Zero-shot Image-to-Image Translation"),Es=d(),A=n("h2"),J=n("a"),Ct=n("span"),u(ue.$$.fragment),Gn=d(),zt=n("span"),On=o("Overview"),Ss=d(),me=n("p"),he=n("a"),Fn=o("Zero-shot Image-to-Image Translation"),Bn=o(" by Gaurav Parmar, Krishna Kumar Singh, Richard Zhang, Yijun Li, Jingwan Lu, and Jun-Yan Zhu."),qs=d(),it=n("p"),Un=o("The abstract of the paper is the following:"),Ts=d(),ot=n("p"),Zt=n("em"),Hn=o("Large-scale text-to-image generative models have shown their remarkable ability to synthesize diverse and high-quality images. However, it is still challenging to directly apply these models for editing real images for two reasons. First, it is hard for users to come up with a perfect text prompt that accurately describes every visual detail in the input image. Second, while existing models can introduce desirable changes in certain regions, they often dramatically alter the input content and introduce unexpected changes in unwanted regions. In this work, we propose pix2pix-zero, an image-to-image translation method that can preserve the content of the original image without manual prompting. We first automatically discover editing directions that reflect desired edits in the text embedding space. To preserve the general content structure after editing, we further propose cross-attention guidance, which aims to retain the cross-attention maps of the input image throughout the diffusion process. In addition, our method does not need additional training for these edits and can directly use the existing pre-trained text-to-image diffusion model. We conduct extensive experiments and show that our method outperforms existing and concurrent works for both real and synthetic image editing."),Is=d(),rt=n("p"),Rn=o("Resources:"),Cs=d(),T=n("ul"),lt=n("li"),ge=n("a"),Wn=o("Project Page"),Vn=o("."),Kn=d(),pt=n("li"),_e=n("a"),Yn=o("Paper"),Jn=o("."),Xn=d(),dt=n("li"),be=n("a"),Qn=o("Original Code"),ea=o("."),zs=d(),L=n("h2"),X=n("a"),At=n("span"),u(ve.$$.fragment),ta=d(),Lt=n("span"),sa=o("Tips"),Zs=d(),$=n("ul"),Nt=n("li"),na=o("The pipeline can be conditioned on real input images. Check out the code examples below to know more."),aa=d(),j=n("li"),ia=o("The pipeline exposes two arguments namely "),Mt=n("code"),oa=o("source_embeds"),ra=o(" and "),Gt=n("code"),la=o("target_embeds"),pa=o(`
that let you control the direction of the semantic edits in the final image to be generated. Let\u2019s say,
you wanted to translate from \u201Ccat\u201D to \u201Cdog\u201D. In this case, the edit direction will be \u201Ccat -> dog\u201D. To reflect
this in the pipeline, you simply have to set the embeddings related to the phrases including \u201Ccat\u201D to
`),Ot=n("code"),da=o("source_embeds"),ca=o(" and \u201Cdog\u201D to "),Ft=n("code"),fa=o("target_embeds"),ua=o(". Refer to the code example below for more details."),ma=d(),N=n("li"),ha=o("When you\u2019re using this pipeline from a prompt, specify the "),Bt=n("em"),ga=o("source"),_a=o(` concept in the prompt. Taking
the above example, a valid input prompt would be: \u201Ca high resolution painting of a `),Ut=n("strong"),ba=o("cat"),va=o(" in the style of van gough\u201D."),xa=d(),ct=n("li"),wa=o("If you wanted to reverse the direction in the example above, i.e., \u201Cdog -> cat\u201D, then it\u2019s recommended to:"),xe=n("ul"),M=n("li"),Pa=o("Swap the "),Ht=n("code"),ya=o("source_embeds"),$a=o(" and "),Rt=n("code"),ka=o("target_embeds"),ja=o("."),Da=d(),Wt=n("li"),Ea=o("Change the input prompt to include \u201Cdog\u201D."),Sa=d(),we=n("li"),qa=o("To learn more about how the source and target embeddings are generated, refer to the "),Pe=n("a"),Ta=o(`original
paper`),Ia=o(". Below, we also provide some directions on how to generate the embeddings."),As=d(),G=n("h2"),Q=n("a"),Vt=n("span"),u(ye.$$.fragment),Ca=d(),Kt=n("span"),za=o("Available Pipelines:"),Ls=d(),ee=n("table"),Yt=n("thead"),O=n("tr"),Jt=n("th"),Za=o("Pipeline"),Aa=d(),Xt=n("th"),La=o("Tasks"),Na=d(),ft=n("th"),Ma=o("Demo"),Ga=d(),Qt=n("tbody"),F=n("tr"),es=n("td"),$e=n("a"),Oa=o("StableDiffusionPix2PixZeroPipeline"),Fa=d(),ts=n("td"),ss=n("em"),Ba=o("Text-Based Image Editing"),Ua=d(),ut=n("td"),Ha=o("[\u{1F917} Space] (soon)"),Ns=d(),B=n("h2"),te=n("a"),ns=n("span"),u(ke.$$.fragment),Ra=d(),as=n("span"),Wa=o("Usage example"),Ms=d(),U=n("h3"),se=n("a"),is=n("span"),u(je.$$.fragment),Va=d(),os=n("span"),Ka=o("Based on an image generated with the input prompt"),Gs=d(),u(De.$$.fragment),Os=d(),H=n("h3"),ne=n("a"),rs=n("span"),u(Ee.$$.fragment),Ya=d(),ls=n("span"),Ja=o("Based on an input image"),Fs=d(),ae=n("p"),Xa=o(`When the pipeline is conditioned on an input image, we first obtain an inverted
noise from it using a `),ps=n("code"),Qa=o("DDIMInverseScheduler"),ei=o(` with the help of a generated caption. Then
the inverted noise is used to start the generation process.`),Bs=d(),mt=n("p"),ti=o("First, let\u2019s load our pipeline:"),Us=d(),u(Se.$$.fragment),Hs=d(),ht=n("p"),si=o("Then, we load an input image for conditioning and obtain a suitable caption for it:"),Rs=d(),u(qe.$$.fragment),Ws=d(),gt=n("p"),ni=o("Then we employ the generated caption and the input image to get the inverted noise:"),Vs=d(),u(Te.$$.fragment),Ks=d(),_t=n("p"),ai=o("Now, generate the image with edit directions:"),Ys=d(),u(Ie.$$.fragment),Js=d(),R=n("h2"),ie=n("a"),ds=n("span"),u(Ce.$$.fragment),ii=d(),cs=n("span"),oi=o("Generating source and target embeddings"),Xs=d(),E=n("p"),ri=o("The authors originally used the "),ze=n("a"),li=o("GPT-3 API"),pi=o(` to generate the source and target captions for discovering
edit directions. However, we can also leverage open source and public models for the same purpose.
Below, we provide an end-to-end example with the `),Ze=n("a"),di=o("Flan-T5"),ci=o(` model
for generating captions and `),Ae=n("a"),fi=o("CLIP"),ui=o(` for
computing embeddings on the generated captions.`),Qs=d(),Le=n("p"),fs=n("strong"),mi=o("1. Load the generation model"),hi=o(":"),en=d(),u(Ne.$$.fragment),tn=d(),Me=n("p"),us=n("strong"),gi=o("2. Construct a starting prompt"),_i=o(":"),sn=d(),u(Ge.$$.fragment),nn=d(),bt=n("p"),bi=o("Here, we\u2019re interested in the \u201Ccat -> dog\u201D direction."),an=d(),Oe=n("p"),ms=n("strong"),vi=o("3. Generate captions"),xi=o(":"),on=d(),vt=n("p"),wi=o("We can use a utility like so for this purpose."),rn=d(),u(Fe.$$.fragment),ln=d(),xt=n("p"),Pi=o("And then we just call it to generate our captions:"),pn=d(),u(Be.$$.fragment),dn=d(),I=n("p"),yi=o(`We encourage you to play around with the different parameters supported by the
`),hs=n("code"),$i=o("generate()"),ki=o(" method ("),Ue=n("a"),ji=o("documentation"),Di=o(") for the generation quality you are looking for."),cn=d(),He=n("p"),gs=n("strong"),Ei=o("4. Load the embedding model"),Si=o(":"),fn=d(),wt=n("p"),qi=o("Here, we need to use the same text encoder model used by the subsequent Stable Diffusion model."),un=d(),u(Re.$$.fragment),mn=d(),We=n("p"),_s=n("strong"),Ti=o("5. Compute embeddings"),Ii=o(":"),hn=d(),u(Ve.$$.fragment),gn=d(),oe=n("p"),Ci=o("And you\u2019re done! "),Ke=n("a"),zi=o("Here"),Zi=o(" is a Colab Notebook that you can use to interact with the entire process."),_n=d(),Pt=n("p"),Ai=o("Now, you can use these embeddings directly while calling the pipeline:"),bn=d(),u(Ye.$$.fragment),vn=d(),W=n("h2"),re=n("a"),bs=n("span"),u(Je.$$.fragment),Li=d(),vs=n("span"),Ni=o("StableDiffusionPix2PixZeroPipeline"),xn=d(),x=n("div"),u(Xe.$$.fragment),Mi=d(),xs=n("p"),Gi=o("Pipeline for pixel-levl image editing using Pix2Pix Zero. Based on Stable Diffusion."),Oi=d(),Qe=n("p"),Fi=o("This model inherits from "),yt=n("a"),Bi=o("DiffusionPipeline"),Ui=o(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Hi=d(),C=n("div"),u(et.$$.fragment),Ri=d(),ws=n("p"),Wi=o("Function invoked when calling the pipeline for generation."),Vi=d(),u(le.$$.fragment),Ki=d(),pe=n("div"),u(tt.$$.fragment),Yi=d(),Ps=n("p"),Ji=o("Constructs the edit direction to steer the image generation process semantically."),Xi=d(),de=n("div"),u(st.$$.fragment),Qi=d(),V=n("p"),eo=o(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),ys=n("code"),to=o("torch.device('meta') and loaded to GPU only when their specific submodule has its "),so=o("forward"),$s=n("code"),no=o("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),ao=o("enable_model_cpu_offload`, but performance is lower."),io=d(),ce=n("div"),u(nt.$$.fragment),oo=d(),ks=n("p"),ro=o("Generates caption for a given image."),this.h()},l(e){const l=Xr('[data-svelte="svelte-1phssyn"]',document.head);w=a(l,"META",{name:!0,content:!0}),l.forEach(s),Y=c(e),y=a(e,"H1",{class:!0});var at=i(y);P=a(at,"A",{id:!0,class:!0,href:!0});var vo=i(P);S=a(vo,"SPAN",{});var xo=i(S);m(v.$$.fragment,xo),xo.forEach(s),vo.forEach(s),q=c(at),It=a(at,"SPAN",{});var wo=i(It);Mn=r(wo,"Zero-shot Image-to-Image Translation"),wo.forEach(s),at.forEach(s),Es=c(e),A=a(e,"H2",{class:!0});var Pn=i(A);J=a(Pn,"A",{id:!0,class:!0,href:!0});var Po=i(J);Ct=a(Po,"SPAN",{});var yo=i(Ct);m(ue.$$.fragment,yo),yo.forEach(s),Po.forEach(s),Gn=c(Pn),zt=a(Pn,"SPAN",{});var $o=i(zt);On=r($o,"Overview"),$o.forEach(s),Pn.forEach(s),Ss=c(e),me=a(e,"P",{});var lo=i(me);he=a(lo,"A",{href:!0,rel:!0});var ko=i(he);Fn=r(ko,"Zero-shot Image-to-Image Translation"),ko.forEach(s),Bn=r(lo," by Gaurav Parmar, Krishna Kumar Singh, Richard Zhang, Yijun Li, Jingwan Lu, and Jun-Yan Zhu."),lo.forEach(s),qs=c(e),it=a(e,"P",{});var jo=i(it);Un=r(jo,"The abstract of the paper is the following:"),jo.forEach(s),Ts=c(e),ot=a(e,"P",{});var Do=i(ot);Zt=a(Do,"EM",{});var Eo=i(Zt);Hn=r(Eo,"Large-scale text-to-image generative models have shown their remarkable ability to synthesize diverse and high-quality images. However, it is still challenging to directly apply these models for editing real images for two reasons. First, it is hard for users to come up with a perfect text prompt that accurately describes every visual detail in the input image. Second, while existing models can introduce desirable changes in certain regions, they often dramatically alter the input content and introduce unexpected changes in unwanted regions. In this work, we propose pix2pix-zero, an image-to-image translation method that can preserve the content of the original image without manual prompting. We first automatically discover editing directions that reflect desired edits in the text embedding space. To preserve the general content structure after editing, we further propose cross-attention guidance, which aims to retain the cross-attention maps of the input image throughout the diffusion process. In addition, our method does not need additional training for these edits and can directly use the existing pre-trained text-to-image diffusion model. We conduct extensive experiments and show that our method outperforms existing and concurrent works for both real and synthetic image editing."),Eo.forEach(s),Do.forEach(s),Is=c(e),rt=a(e,"P",{});var So=i(rt);Rn=r(So,"Resources:"),So.forEach(s),Cs=c(e),T=a(e,"UL",{});var $t=i(T);lt=a($t,"LI",{});var po=i(lt);ge=a(po,"A",{href:!0,rel:!0});var qo=i(ge);Wn=r(qo,"Project Page"),qo.forEach(s),Vn=r(po,"."),po.forEach(s),Kn=c($t),pt=a($t,"LI",{});var co=i(pt);_e=a(co,"A",{href:!0,rel:!0});var To=i(_e);Yn=r(To,"Paper"),To.forEach(s),Jn=r(co,"."),co.forEach(s),Xn=c($t),dt=a($t,"LI",{});var fo=i(dt);be=a(fo,"A",{href:!0,rel:!0});var Io=i(be);Qn=r(Io,"Original Code"),Io.forEach(s),ea=r(fo,"."),fo.forEach(s),$t.forEach(s),zs=c(e),L=a(e,"H2",{class:!0});var yn=i(L);X=a(yn,"A",{id:!0,class:!0,href:!0});var Co=i(X);At=a(Co,"SPAN",{});var zo=i(At);m(ve.$$.fragment,zo),zo.forEach(s),Co.forEach(s),ta=c(yn),Lt=a(yn,"SPAN",{});var Zo=i(Lt);sa=r(Zo,"Tips"),Zo.forEach(s),yn.forEach(s),Zs=c(e),$=a(e,"UL",{});var z=i($);Nt=a(z,"LI",{});var Ao=i(Nt);na=r(Ao,"The pipeline can be conditioned on real input images. Check out the code examples below to know more."),Ao.forEach(s),aa=c(z),j=a(z,"LI",{});var Z=i(j);ia=r(Z,"The pipeline exposes two arguments namely "),Mt=a(Z,"CODE",{});var Lo=i(Mt);oa=r(Lo,"source_embeds"),Lo.forEach(s),ra=r(Z," and "),Gt=a(Z,"CODE",{});var No=i(Gt);la=r(No,"target_embeds"),No.forEach(s),pa=r(Z,`
that let you control the direction of the semantic edits in the final image to be generated. Let\u2019s say,
you wanted to translate from \u201Ccat\u201D to \u201Cdog\u201D. In this case, the edit direction will be \u201Ccat -> dog\u201D. To reflect
this in the pipeline, you simply have to set the embeddings related to the phrases including \u201Ccat\u201D to
`),Ot=a(Z,"CODE",{});var Mo=i(Ot);da=r(Mo,"source_embeds"),Mo.forEach(s),ca=r(Z," and \u201Cdog\u201D to "),Ft=a(Z,"CODE",{});var Go=i(Ft);fa=r(Go,"target_embeds"),Go.forEach(s),ua=r(Z,". Refer to the code example below for more details."),Z.forEach(s),ma=c(z),N=a(z,"LI",{});var kt=i(N);ha=r(kt,"When you\u2019re using this pipeline from a prompt, specify the "),Bt=a(kt,"EM",{});var Oo=i(Bt);ga=r(Oo,"source"),Oo.forEach(s),_a=r(kt,` concept in the prompt. Taking
the above example, a valid input prompt would be: \u201Ca high resolution painting of a `),Ut=a(kt,"STRONG",{});var Fo=i(Ut);ba=r(Fo,"cat"),Fo.forEach(s),va=r(kt," in the style of van gough\u201D."),kt.forEach(s),xa=c(z),ct=a(z,"LI",{});var uo=i(ct);wa=r(uo,"If you wanted to reverse the direction in the example above, i.e., \u201Cdog -> cat\u201D, then it\u2019s recommended to:"),xe=a(uo,"UL",{});var $n=i(xe);M=a($n,"LI",{});var jt=i(M);Pa=r(jt,"Swap the "),Ht=a(jt,"CODE",{});var Bo=i(Ht);ya=r(Bo,"source_embeds"),Bo.forEach(s),$a=r(jt," and "),Rt=a(jt,"CODE",{});var Uo=i(Rt);ka=r(Uo,"target_embeds"),Uo.forEach(s),ja=r(jt,"."),jt.forEach(s),Da=c($n),Wt=a($n,"LI",{});var Ho=i(Wt);Ea=r(Ho,"Change the input prompt to include \u201Cdog\u201D."),Ho.forEach(s),$n.forEach(s),uo.forEach(s),Sa=c(z),we=a(z,"LI",{});var kn=i(we);qa=r(kn,"To learn more about how the source and target embeddings are generated, refer to the "),Pe=a(kn,"A",{href:!0,rel:!0});var Ro=i(Pe);Ta=r(Ro,`original
paper`),Ro.forEach(s),Ia=r(kn,". Below, we also provide some directions on how to generate the embeddings."),kn.forEach(s),z.forEach(s),As=c(e),G=a(e,"H2",{class:!0});var jn=i(G);Q=a(jn,"A",{id:!0,class:!0,href:!0});var Wo=i(Q);Vt=a(Wo,"SPAN",{});var Vo=i(Vt);m(ye.$$.fragment,Vo),Vo.forEach(s),Wo.forEach(s),Ca=c(jn),Kt=a(jn,"SPAN",{});var Ko=i(Kt);za=r(Ko,"Available Pipelines:"),Ko.forEach(s),jn.forEach(s),Ls=c(e),ee=a(e,"TABLE",{});var Dn=i(ee);Yt=a(Dn,"THEAD",{});var Yo=i(Yt);O=a(Yo,"TR",{});var Dt=i(O);Jt=a(Dt,"TH",{});var Jo=i(Jt);Za=r(Jo,"Pipeline"),Jo.forEach(s),Aa=c(Dt),Xt=a(Dt,"TH",{});var Xo=i(Xt);La=r(Xo,"Tasks"),Xo.forEach(s),Na=c(Dt),ft=a(Dt,"TH",{align:!0});var Qo=i(ft);Ma=r(Qo,"Demo"),Qo.forEach(s),Dt.forEach(s),Yo.forEach(s),Ga=c(Dn),Qt=a(Dn,"TBODY",{});var er=i(Qt);F=a(er,"TR",{});var Et=i(F);es=a(Et,"TD",{});var tr=i(es);$e=a(tr,"A",{href:!0,rel:!0});var sr=i($e);Oa=r(sr,"StableDiffusionPix2PixZeroPipeline"),sr.forEach(s),tr.forEach(s),Fa=c(Et),ts=a(Et,"TD",{});var nr=i(ts);ss=a(nr,"EM",{});var ar=i(ss);Ba=r(ar,"Text-Based Image Editing"),ar.forEach(s),nr.forEach(s),Ua=c(Et),ut=a(Et,"TD",{align:!0});var ir=i(ut);Ha=r(ir,"[\u{1F917} Space] (soon)"),ir.forEach(s),Et.forEach(s),er.forEach(s),Dn.forEach(s),Ns=c(e),B=a(e,"H2",{class:!0});var En=i(B);te=a(En,"A",{id:!0,class:!0,href:!0});var or=i(te);ns=a(or,"SPAN",{});var rr=i(ns);m(ke.$$.fragment,rr),rr.forEach(s),or.forEach(s),Ra=c(En),as=a(En,"SPAN",{});var lr=i(as);Wa=r(lr,"Usage example"),lr.forEach(s),En.forEach(s),Ms=c(e),U=a(e,"H3",{class:!0});var Sn=i(U);se=a(Sn,"A",{id:!0,class:!0,href:!0});var pr=i(se);is=a(pr,"SPAN",{});var dr=i(is);m(je.$$.fragment,dr),dr.forEach(s),pr.forEach(s),Va=c(Sn),os=a(Sn,"SPAN",{});var cr=i(os);Ka=r(cr,"Based on an image generated with the input prompt"),cr.forEach(s),Sn.forEach(s),Gs=c(e),m(De.$$.fragment,e),Os=c(e),H=a(e,"H3",{class:!0});var qn=i(H);ne=a(qn,"A",{id:!0,class:!0,href:!0});var fr=i(ne);rs=a(fr,"SPAN",{});var ur=i(rs);m(Ee.$$.fragment,ur),ur.forEach(s),fr.forEach(s),Ya=c(qn),ls=a(qn,"SPAN",{});var mr=i(ls);Ja=r(mr,"Based on an input image"),mr.forEach(s),qn.forEach(s),Fs=c(e),ae=a(e,"P",{});var Tn=i(ae);Xa=r(Tn,`When the pipeline is conditioned on an input image, we first obtain an inverted
noise from it using a `),ps=a(Tn,"CODE",{});var hr=i(ps);Qa=r(hr,"DDIMInverseScheduler"),hr.forEach(s),ei=r(Tn,` with the help of a generated caption. Then
the inverted noise is used to start the generation process.`),Tn.forEach(s),Bs=c(e),mt=a(e,"P",{});var gr=i(mt);ti=r(gr,"First, let\u2019s load our pipeline:"),gr.forEach(s),Us=c(e),m(Se.$$.fragment,e),Hs=c(e),ht=a(e,"P",{});var _r=i(ht);si=r(_r,"Then, we load an input image for conditioning and obtain a suitable caption for it:"),_r.forEach(s),Rs=c(e),m(qe.$$.fragment,e),Ws=c(e),gt=a(e,"P",{});var br=i(gt);ni=r(br,"Then we employ the generated caption and the input image to get the inverted noise:"),br.forEach(s),Vs=c(e),m(Te.$$.fragment,e),Ks=c(e),_t=a(e,"P",{});var vr=i(_t);ai=r(vr,"Now, generate the image with edit directions:"),vr.forEach(s),Ys=c(e),m(Ie.$$.fragment,e),Js=c(e),R=a(e,"H2",{class:!0});var In=i(R);ie=a(In,"A",{id:!0,class:!0,href:!0});var xr=i(ie);ds=a(xr,"SPAN",{});var wr=i(ds);m(Ce.$$.fragment,wr),wr.forEach(s),xr.forEach(s),ii=c(In),cs=a(In,"SPAN",{});var Pr=i(cs);oi=r(Pr,"Generating source and target embeddings"),Pr.forEach(s),In.forEach(s),Xs=c(e),E=a(e,"P",{});var fe=i(E);ri=r(fe,"The authors originally used the "),ze=a(fe,"A",{href:!0,rel:!0});var yr=i(ze);li=r(yr,"GPT-3 API"),yr.forEach(s),pi=r(fe,` to generate the source and target captions for discovering
edit directions. However, we can also leverage open source and public models for the same purpose.
Below, we provide an end-to-end example with the `),Ze=a(fe,"A",{href:!0,rel:!0});var $r=i(Ze);di=r($r,"Flan-T5"),$r.forEach(s),ci=r(fe,` model
for generating captions and `),Ae=a(fe,"A",{href:!0,rel:!0});var kr=i(Ae);fi=r(kr,"CLIP"),kr.forEach(s),ui=r(fe,` for
computing embeddings on the generated captions.`),fe.forEach(s),Qs=c(e),Le=a(e,"P",{});var mo=i(Le);fs=a(mo,"STRONG",{});var jr=i(fs);mi=r(jr,"1. Load the generation model"),jr.forEach(s),hi=r(mo,":"),mo.forEach(s),en=c(e),m(Ne.$$.fragment,e),tn=c(e),Me=a(e,"P",{});var ho=i(Me);us=a(ho,"STRONG",{});var Dr=i(us);gi=r(Dr,"2. Construct a starting prompt"),Dr.forEach(s),_i=r(ho,":"),ho.forEach(s),sn=c(e),m(Ge.$$.fragment,e),nn=c(e),bt=a(e,"P",{});var Er=i(bt);bi=r(Er,"Here, we\u2019re interested in the \u201Ccat -> dog\u201D direction."),Er.forEach(s),an=c(e),Oe=a(e,"P",{});var go=i(Oe);ms=a(go,"STRONG",{});var Sr=i(ms);vi=r(Sr,"3. Generate captions"),Sr.forEach(s),xi=r(go,":"),go.forEach(s),on=c(e),vt=a(e,"P",{});var qr=i(vt);wi=r(qr,"We can use a utility like so for this purpose."),qr.forEach(s),rn=c(e),m(Fe.$$.fragment,e),ln=c(e),xt=a(e,"P",{});var Tr=i(xt);Pi=r(Tr,"And then we just call it to generate our captions:"),Tr.forEach(s),pn=c(e),m(Be.$$.fragment,e),dn=c(e),I=a(e,"P",{});var St=i(I);yi=r(St,`We encourage you to play around with the different parameters supported by the
`),hs=a(St,"CODE",{});var Ir=i(hs);$i=r(Ir,"generate()"),Ir.forEach(s),ki=r(St," method ("),Ue=a(St,"A",{href:!0,rel:!0});var Cr=i(Ue);ji=r(Cr,"documentation"),Cr.forEach(s),Di=r(St,") for the generation quality you are looking for."),St.forEach(s),cn=c(e),He=a(e,"P",{});var _o=i(He);gs=a(_o,"STRONG",{});var zr=i(gs);Ei=r(zr,"4. Load the embedding model"),zr.forEach(s),Si=r(_o,":"),_o.forEach(s),fn=c(e),wt=a(e,"P",{});var Zr=i(wt);qi=r(Zr,"Here, we need to use the same text encoder model used by the subsequent Stable Diffusion model."),Zr.forEach(s),un=c(e),m(Re.$$.fragment,e),mn=c(e),We=a(e,"P",{});var bo=i(We);_s=a(bo,"STRONG",{});var Ar=i(_s);Ti=r(Ar,"5. Compute embeddings"),Ar.forEach(s),Ii=r(bo,":"),bo.forEach(s),hn=c(e),m(Ve.$$.fragment,e),gn=c(e),oe=a(e,"P",{});var Cn=i(oe);Ci=r(Cn,"And you\u2019re done! "),Ke=a(Cn,"A",{href:!0,rel:!0});var Lr=i(Ke);zi=r(Lr,"Here"),Lr.forEach(s),Zi=r(Cn," is a Colab Notebook that you can use to interact with the entire process."),Cn.forEach(s),_n=c(e),Pt=a(e,"P",{});var Nr=i(Pt);Ai=r(Nr,"Now, you can use these embeddings directly while calling the pipeline:"),Nr.forEach(s),bn=c(e),m(Ye.$$.fragment,e),vn=c(e),W=a(e,"H2",{class:!0});var zn=i(W);re=a(zn,"A",{id:!0,class:!0,href:!0});var Mr=i(re);bs=a(Mr,"SPAN",{});var Gr=i(bs);m(Je.$$.fragment,Gr),Gr.forEach(s),Mr.forEach(s),Li=c(zn),vs=a(zn,"SPAN",{});var Or=i(vs);Ni=r(Or,"StableDiffusionPix2PixZeroPipeline"),Or.forEach(s),zn.forEach(s),xn=c(e),x=a(e,"DIV",{class:!0});var k=i(x);m(Xe.$$.fragment,k),Mi=c(k),xs=a(k,"P",{});var Fr=i(xs);Gi=r(Fr,"Pipeline for pixel-levl image editing using Pix2Pix Zero. Based on Stable Diffusion."),Fr.forEach(s),Oi=c(k),Qe=a(k,"P",{});var Zn=i(Qe);Fi=r(Zn,"This model inherits from "),yt=a(Zn,"A",{href:!0});var Br=i(yt);Bi=r(Br,"DiffusionPipeline"),Br.forEach(s),Ui=r(Zn,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Zn.forEach(s),Hi=c(k),C=a(k,"DIV",{class:!0});var qt=i(C);m(et.$$.fragment,qt),Ri=c(qt),ws=a(qt,"P",{});var Ur=i(ws);Wi=r(Ur,"Function invoked when calling the pipeline for generation."),Ur.forEach(s),Vi=c(qt),m(le.$$.fragment,qt),qt.forEach(s),Ki=c(k),pe=a(k,"DIV",{class:!0});var An=i(pe);m(tt.$$.fragment,An),Yi=c(An),Ps=a(An,"P",{});var Hr=i(Ps);Ji=r(Hr,"Constructs the edit direction to steer the image generation process semantically."),Hr.forEach(s),An.forEach(s),Xi=c(k),de=a(k,"DIV",{class:!0});var Ln=i(de);m(st.$$.fragment,Ln),Qi=c(Ln),V=a(Ln,"P",{});var Tt=i(V);eo=r(Tt,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),ys=a(Tt,"CODE",{});var Rr=i(ys);to=r(Rr,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Rr.forEach(s),so=r(Tt,"forward"),$s=a(Tt,"CODE",{});var Wr=i($s);no=r(Wr,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Wr.forEach(s),ao=r(Tt,"enable_model_cpu_offload`, but performance is lower."),Tt.forEach(s),Ln.forEach(s),io=c(k),ce=a(k,"DIV",{class:!0});var Nn=i(ce);m(nt.$$.fragment,Nn),oo=c(Nn),ks=a(Nn,"P",{});var Vr=i(ks);ro=r(Vr,"Generates caption for a given image."),Vr.forEach(s),Nn.forEach(s),k.forEach(s),this.h()},h(){f(w,"name","hf:doc:metadata"),f(w,"content",JSON.stringify(al)),f(P,"id","zeroshot-imagetoimage-translation"),f(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(P,"href","#zeroshot-imagetoimage-translation"),f(y,"class","relative group"),f(J,"id","overview"),f(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(J,"href","#overview"),f(A,"class","relative group"),f(he,"href","https://arxiv.org/abs/2302.03027"),f(he,"rel","nofollow"),f(ge,"href","https://pix2pixzero.github.io/"),f(ge,"rel","nofollow"),f(_e,"href","https://arxiv.org/abs/2302.03027"),f(_e,"rel","nofollow"),f(be,"href","https://github.com/pix2pixzero/pix2pix-zero"),f(be,"rel","nofollow"),f(X,"id","tips"),f(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(X,"href","#tips"),f(L,"class","relative group"),f(Pe,"href","https://arxiv.org/abs/2302.03027"),f(Pe,"rel","nofollow"),f(Q,"id","available-pipelines"),f(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Q,"href","#available-pipelines"),f(G,"class","relative group"),f(ft,"align","center"),f($e,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_pix2pix_zero.py"),f($e,"rel","nofollow"),f(ut,"align","center"),f(te,"id","usage-example"),f(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(te,"href","#usage-example"),f(B,"class","relative group"),f(se,"id","based-on-an-image-generated-with-the-input-prompt"),f(se,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(se,"href","#based-on-an-image-generated-with-the-input-prompt"),f(U,"class","relative group"),f(ne,"id","based-on-an-input-image"),f(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ne,"href","#based-on-an-input-image"),f(H,"class","relative group"),f(ie,"id","generating-source-and-target-embeddings"),f(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(ie,"href","#generating-source-and-target-embeddings"),f(R,"class","relative group"),f(ze,"href","https://openai.com/api/"),f(ze,"rel","nofollow"),f(Ze,"href","https://huggingface.co/docs/transformers/model_doc/flan-t5"),f(Ze,"rel","nofollow"),f(Ae,"href","https://huggingface.co/docs/transformers/model_doc/clip"),f(Ae,"rel","nofollow"),f(Ue,"href","https://huggingface.co/docs/transformers/main/en/main_classes/text_generation#transformers.generation_tf_utils.TFGenerationMixin.generate"),f(Ue,"rel","nofollow"),f(Ke,"href","https://colab.research.google.com/drive/1tz2C1EdfZYAPlzXXbTnf-5PRBiR8_R1F?usp=sharing"),f(Ke,"rel","nofollow"),f(re,"id","diffusers.StableDiffusionPix2PixZeroPipeline"),f(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(re,"href","#diffusers.StableDiffusionPix2PixZeroPipeline"),f(W,"class","relative group"),f(yt,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),f(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),f(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,l){t(document.head,w),p(e,Y,l),p(e,y,l),t(y,P),t(P,S),h(v,S,null),t(y,q),t(y,It),t(It,Mn),p(e,Es,l),p(e,A,l),t(A,J),t(J,Ct),h(ue,Ct,null),t(A,Gn),t(A,zt),t(zt,On),p(e,Ss,l),p(e,me,l),t(me,he),t(he,Fn),t(me,Bn),p(e,qs,l),p(e,it,l),t(it,Un),p(e,Ts,l),p(e,ot,l),t(ot,Zt),t(Zt,Hn),p(e,Is,l),p(e,rt,l),t(rt,Rn),p(e,Cs,l),p(e,T,l),t(T,lt),t(lt,ge),t(ge,Wn),t(lt,Vn),t(T,Kn),t(T,pt),t(pt,_e),t(_e,Yn),t(pt,Jn),t(T,Xn),t(T,dt),t(dt,be),t(be,Qn),t(dt,ea),p(e,zs,l),p(e,L,l),t(L,X),t(X,At),h(ve,At,null),t(L,ta),t(L,Lt),t(Lt,sa),p(e,Zs,l),p(e,$,l),t($,Nt),t(Nt,na),t($,aa),t($,j),t(j,ia),t(j,Mt),t(Mt,oa),t(j,ra),t(j,Gt),t(Gt,la),t(j,pa),t(j,Ot),t(Ot,da),t(j,ca),t(j,Ft),t(Ft,fa),t(j,ua),t($,ma),t($,N),t(N,ha),t(N,Bt),t(Bt,ga),t(N,_a),t(N,Ut),t(Ut,ba),t(N,va),t($,xa),t($,ct),t(ct,wa),t(ct,xe),t(xe,M),t(M,Pa),t(M,Ht),t(Ht,ya),t(M,$a),t(M,Rt),t(Rt,ka),t(M,ja),t(xe,Da),t(xe,Wt),t(Wt,Ea),t($,Sa),t($,we),t(we,qa),t(we,Pe),t(Pe,Ta),t(we,Ia),p(e,As,l),p(e,G,l),t(G,Q),t(Q,Vt),h(ye,Vt,null),t(G,Ca),t(G,Kt),t(Kt,za),p(e,Ls,l),p(e,ee,l),t(ee,Yt),t(Yt,O),t(O,Jt),t(Jt,Za),t(O,Aa),t(O,Xt),t(Xt,La),t(O,Na),t(O,ft),t(ft,Ma),t(ee,Ga),t(ee,Qt),t(Qt,F),t(F,es),t(es,$e),t($e,Oa),t(F,Fa),t(F,ts),t(ts,ss),t(ss,Ba),t(F,Ua),t(F,ut),t(ut,Ha),p(e,Ns,l),p(e,B,l),t(B,te),t(te,ns),h(ke,ns,null),t(B,Ra),t(B,as),t(as,Wa),p(e,Ms,l),p(e,U,l),t(U,se),t(se,is),h(je,is,null),t(U,Va),t(U,os),t(os,Ka),p(e,Gs,l),h(De,e,l),p(e,Os,l),p(e,H,l),t(H,ne),t(ne,rs),h(Ee,rs,null),t(H,Ya),t(H,ls),t(ls,Ja),p(e,Fs,l),p(e,ae,l),t(ae,Xa),t(ae,ps),t(ps,Qa),t(ae,ei),p(e,Bs,l),p(e,mt,l),t(mt,ti),p(e,Us,l),h(Se,e,l),p(e,Hs,l),p(e,ht,l),t(ht,si),p(e,Rs,l),h(qe,e,l),p(e,Ws,l),p(e,gt,l),t(gt,ni),p(e,Vs,l),h(Te,e,l),p(e,Ks,l),p(e,_t,l),t(_t,ai),p(e,Ys,l),h(Ie,e,l),p(e,Js,l),p(e,R,l),t(R,ie),t(ie,ds),h(Ce,ds,null),t(R,ii),t(R,cs),t(cs,oi),p(e,Xs,l),p(e,E,l),t(E,ri),t(E,ze),t(ze,li),t(E,pi),t(E,Ze),t(Ze,di),t(E,ci),t(E,Ae),t(Ae,fi),t(E,ui),p(e,Qs,l),p(e,Le,l),t(Le,fs),t(fs,mi),t(Le,hi),p(e,en,l),h(Ne,e,l),p(e,tn,l),p(e,Me,l),t(Me,us),t(us,gi),t(Me,_i),p(e,sn,l),h(Ge,e,l),p(e,nn,l),p(e,bt,l),t(bt,bi),p(e,an,l),p(e,Oe,l),t(Oe,ms),t(ms,vi),t(Oe,xi),p(e,on,l),p(e,vt,l),t(vt,wi),p(e,rn,l),h(Fe,e,l),p(e,ln,l),p(e,xt,l),t(xt,Pi),p(e,pn,l),h(Be,e,l),p(e,dn,l),p(e,I,l),t(I,yi),t(I,hs),t(hs,$i),t(I,ki),t(I,Ue),t(Ue,ji),t(I,Di),p(e,cn,l),p(e,He,l),t(He,gs),t(gs,Ei),t(He,Si),p(e,fn,l),p(e,wt,l),t(wt,qi),p(e,un,l),h(Re,e,l),p(e,mn,l),p(e,We,l),t(We,_s),t(_s,Ti),t(We,Ii),p(e,hn,l),h(Ve,e,l),p(e,gn,l),p(e,oe,l),t(oe,Ci),t(oe,Ke),t(Ke,zi),t(oe,Zi),p(e,_n,l),p(e,Pt,l),t(Pt,Ai),p(e,bn,l),h(Ye,e,l),p(e,vn,l),p(e,W,l),t(W,re),t(re,bs),h(Je,bs,null),t(W,Li),t(W,vs),t(vs,Ni),p(e,xn,l),p(e,x,l),h(Xe,x,null),t(x,Mi),t(x,xs),t(xs,Gi),t(x,Oi),t(x,Qe),t(Qe,Fi),t(Qe,yt),t(yt,Bi),t(Qe,Ui),t(x,Hi),t(x,C),h(et,C,null),t(C,Ri),t(C,ws),t(ws,Wi),t(C,Vi),h(le,C,null),t(x,Ki),t(x,pe),h(tt,pe,null),t(pe,Yi),t(pe,Ps),t(Ps,Ji),t(x,Xi),t(x,de),h(st,de,null),t(de,Qi),t(de,V),t(V,eo),t(V,ys),t(ys,to),t(V,so),t(V,$s),t($s,no),t(V,ao),t(x,io),t(x,ce),h(nt,ce,null),t(ce,oo),t(ce,ks),t(ks,ro),wn=!0},p(e,[l]){const at={};l&2&&(at.$$scope={dirty:l,ctx:e}),le.$set(at)},i(e){wn||(g(v.$$.fragment,e),g(ue.$$.fragment,e),g(ve.$$.fragment,e),g(ye.$$.fragment,e),g(ke.$$.fragment,e),g(je.$$.fragment,e),g(De.$$.fragment,e),g(Ee.$$.fragment,e),g(Se.$$.fragment,e),g(qe.$$.fragment,e),g(Te.$$.fragment,e),g(Ie.$$.fragment,e),g(Ce.$$.fragment,e),g(Ne.$$.fragment,e),g(Ge.$$.fragment,e),g(Fe.$$.fragment,e),g(Be.$$.fragment,e),g(Re.$$.fragment,e),g(Ve.$$.fragment,e),g(Ye.$$.fragment,e),g(Je.$$.fragment,e),g(Xe.$$.fragment,e),g(et.$$.fragment,e),g(le.$$.fragment,e),g(tt.$$.fragment,e),g(st.$$.fragment,e),g(nt.$$.fragment,e),wn=!0)},o(e){_(v.$$.fragment,e),_(ue.$$.fragment,e),_(ve.$$.fragment,e),_(ye.$$.fragment,e),_(ke.$$.fragment,e),_(je.$$.fragment,e),_(De.$$.fragment,e),_(Ee.$$.fragment,e),_(Se.$$.fragment,e),_(qe.$$.fragment,e),_(Te.$$.fragment,e),_(Ie.$$.fragment,e),_(Ce.$$.fragment,e),_(Ne.$$.fragment,e),_(Ge.$$.fragment,e),_(Fe.$$.fragment,e),_(Be.$$.fragment,e),_(Re.$$.fragment,e),_(Ve.$$.fragment,e),_(Ye.$$.fragment,e),_(Je.$$.fragment,e),_(Xe.$$.fragment,e),_(et.$$.fragment,e),_(le.$$.fragment,e),_(tt.$$.fragment,e),_(st.$$.fragment,e),_(nt.$$.fragment,e),wn=!1},d(e){s(w),e&&s(Y),e&&s(y),b(v),e&&s(Es),e&&s(A),b(ue),e&&s(Ss),e&&s(me),e&&s(qs),e&&s(it),e&&s(Ts),e&&s(ot),e&&s(Is),e&&s(rt),e&&s(Cs),e&&s(T),e&&s(zs),e&&s(L),b(ve),e&&s(Zs),e&&s($),e&&s(As),e&&s(G),b(ye),e&&s(Ls),e&&s(ee),e&&s(Ns),e&&s(B),b(ke),e&&s(Ms),e&&s(U),b(je),e&&s(Gs),b(De,e),e&&s(Os),e&&s(H),b(Ee),e&&s(Fs),e&&s(ae),e&&s(Bs),e&&s(mt),e&&s(Us),b(Se,e),e&&s(Hs),e&&s(ht),e&&s(Rs),b(qe,e),e&&s(Ws),e&&s(gt),e&&s(Vs),b(Te,e),e&&s(Ks),e&&s(_t),e&&s(Ys),b(Ie,e),e&&s(Js),e&&s(R),b(Ce),e&&s(Xs),e&&s(E),e&&s(Qs),e&&s(Le),e&&s(en),b(Ne,e),e&&s(tn),e&&s(Me),e&&s(sn),b(Ge,e),e&&s(nn),e&&s(bt),e&&s(an),e&&s(Oe),e&&s(on),e&&s(vt),e&&s(rn),b(Fe,e),e&&s(ln),e&&s(xt),e&&s(pn),b(Be,e),e&&s(dn),e&&s(I),e&&s(cn),e&&s(He),e&&s(fn),e&&s(wt),e&&s(un),b(Re,e),e&&s(mn),e&&s(We),e&&s(hn),b(Ve,e),e&&s(gn),e&&s(oe),e&&s(_n),e&&s(Pt),e&&s(bn),b(Ye,e),e&&s(vn),e&&s(W),b(Je),e&&s(xn),e&&s(x),b(Xe),b(et),b(le),b(tt),b(st),b(nt)}}}const al={local:"zeroshot-imagetoimage-translation",sections:[{local:"overview",title:"Overview"},{local:"tips",title:"Tips "},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",sections:[{local:"based-on-an-image-generated-with-the-input-prompt",title:"Based on an image generated with the input prompt"},{local:"based-on-an-input-image",title:"Based on an input image"}],title:"Usage example"},{local:"generating-source-and-target-embeddings",title:"Generating source and target embeddings "},{local:"diffusers.StableDiffusionPix2PixZeroPipeline",title:"StableDiffusionPix2PixZeroPipeline"}],title:"Zero-shot Image-to-Image Translation"};function il(Ds){return Qr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class cl extends Kr{constructor(w){super();Yr(this,w,il,nl,Jr,{})}}export{cl as default,al as metadata};
